﻿DeclareModule Unknown

Structure UnkSctuct
  *VT
  RefCount.l
  IID.GUID
EndStructure

Macro UnkProc
  Data.i @QueryInterface()
  Data.i @AddRef()
  Data.i @Release()
EndMacro

Declare QueryInterface(*This.UnkSctuct, *riid.GUID, *ppvObject.Integer)
Declare AddRef(*This.UnkSctuct)
Declare Release(*This.UnkSctuct)

EndDeclareModule


Module Unknown

Procedure QueryInterface(*This.UnkSctuct, *riid.GUID, *ppvObject.Integer)
  Protected Res = #E_POINTER
  
  If *ppvObject
    If CompareMemory(*riid, @*This\IID, SizeOf(GUID))
      *ppvObject\i = *This
      AddRef(*This)
      Res = #S_OK
    Else
     *ppvObject\i = 0
     Res = #E_NOINTERFACE
    EndIf
  EndIf
  
  ProcedureReturn Res
EndProcedure 

Procedure AddRef(*This.UnkSctuct)
  *This\RefCount+1
  ProcedureReturn *This\RefCount
EndProcedure 

Procedure Release(*This.UnkSctuct)
  *This\RefCount-1
  ProcedureReturn *This\RefCount
EndProcedure 

EndModule
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 37
; FirstLine = 6
; Folding = --
; EnableUnicode
; EnableXP