﻿
Import "/RELEASE" : EndImport

DeclareModule AIMP

Macro REFIID
  GUID
EndMacro

;- apiObjects
;{

DataSection
  IID_IAIMPConfig:
  Data.l $41494D50
  Data.u $436F, $6E66
  Data.a $69, $67, $00, $00, $00, $00, $00, $00
  
  IID_IAIMPErrorInfo:
  Data.l $41494D50
  Data.u $4572, $7249
  Data.a $6E, $66, $6F, $00, $00, $00, $00, $00
  
  IID_IAIMPHashCode:
  Data.l $41494D50
  Data.u $4861, $7368
  Data.a $43, $6F, $64, $65, $00, $00, $00, $00
  
  IID_IAIMPFileStream:
  Data.l $41494D50
  Data.u $4669, $6C65
  Data.a $53, $74, $72, $65, $61, $6D, $00, $00
  
  IID_IAIMPImage:
  Data.l $41494D50
  Data.u $496D, $6167
  Data.a $65, $00, $00, $00, $00, $00, $00, $00
  
  IID_IAIMPImage2:
  Data.l $41494D50
  Data.u $496D, $6167
  Data.a $65, $32, $00, $00, $00, $00, $00, $00
  
  IID_IAIMPImageContainer:
  Data.l $41494D50
  Data.u $496D, $6167
  Data.a $65, $43, $6F, $6E, $74, $6E, $72, $00
  
  IID_IAIMPMemoryStream:
  Data.l $41494D50
  Data.u $4D65, $6D53
  Data.a $74, $72, $65, $61, $6D, $00, $00, $00
  
  IID_IAIMPObjectList:
  Data.l $41494D50
  Data.u $4F62, $6A4C
  Data.a $69, $73, $74, $00, $00, $00, $00, $00
  
  IID_IAIMPProgressCallback:
  Data.l $41494D50
  Data.u $5072, $6F67
  Data.a $72, $65, $73, $73, $43, $42, $00, $00
  
  IID_IAIMPPropertyList:
  Data.l $41494D50
  Data.u $5072, $6F70
  Data.a $4C, $69, $73, $74, $00, $00, $00, $00
  
  IID_IAIMPPropertyList2:
  Data.l $41494D50
  Data.u $5072, $6F70
  Data.a $4C, $69, $73, $74, $32, $00, $00, $00
  
  IID_IAIMPStream:
  Data.l $41494D50
  Data.u $5374, $7265
  Data.a $61, $6D, $00, $00, $00, $00, $00, $00
  
  IID_IAIMPString:
  Data.l $41494D50
  Data.u $5374, $7269
  Data.a $6E, $67, $00, $00, $00, $00, $00, $00
EndDataSection

; IAIMPImage And IAIMPImageContainer FormatID
#AIMP_IMAGE_FORMAT_UNKNOWN = 0;
#AIMP_IMAGE_FORMAT_BMP     = 1;
#AIMP_IMAGE_FORMAT_GIF     = 2;
#AIMP_IMAGE_FORMAT_JPG     = 3;
#AIMP_IMAGE_FORMAT_PNG     = 4;

; Flags For IAIMPImage.Draw
#AIMP_IMAGE_DRAW_STRETCHMODE_STRETCH = 0;
#AIMP_IMAGE_DRAW_STRETCHMODE_FILL    = 1;
#AIMP_IMAGE_DRAW_STRETCHMODE_FIT     = 2;
#AIMP_IMAGE_DRAW_STRETCHMODE_TILE    = 4;
#AIMP_IMAGE_DRAW_QUALITY_DEFAULT     = 0;
#AIMP_IMAGE_DRAW_QUALITY_LOW         = 8;
#AIMP_IMAGE_DRAW_QUALITY_HIGH        = 16;

; IAIMPPropertyList
#AIMP_PROPERTYLIST_CUSTOM_PROPID_BASE = 1000;

; Flags For IAIMPString.ChangeCase
#AIMP_STRING_CASE_LOWER                          = 1;
#AIMP_STRING_CASE_UPPER                          = 2;
#AIMP_STRING_CASE_ALL_WORDS_WITH_CAPICAL_LETTER  = 3;
#AIMP_STRING_CASE_FIRST_WORD_WITH_CAPICAL_LETTER = 4;

; Flags For IAIMPString.Find And IAIMPString.Replace
#AIMP_STRING_FIND_IGNORECASE = 1;
#AIMP_STRING_FIND_WHOLEWORD  = 2;

; IAIMPStream.Seet Mode
#AIMP_STREAM_SEEKMODE_FROM_BEGINNING = 0;
#AIMP_STREAM_SEEKMODE_FROM_CURRENT   = 1;
#AIMP_STREAM_SEEKMODE_FROM_END       = 2;

; IAIMPHashCode

Interface IAIMPHashCode Extends IUnknown
  GetHashCode()
  Recalculate()
EndInterface

; IAIMPObjectList

Interface IAIMPObjectList Extends IUnknown
  Add(*Obj.IUnknown)
  Clear()
  Delete(Index)
  Insert(Index, *Obj.IUnknown)
  
  vGetCount()
  GetObject(Index, *IID.REFIID, *Obj)
  SetObject(Index, *Obj.IUnknown)
EndInterface

; IAIMPString

Interface IAIMPString Extends IUnknown
  GetChar(Index, *Char.Unicode)
  GetData.s()
  GetLength()
  GetHashCode()
  SetChar(Index, *Char.Unicode)
  SetData(Chars.s, CharsCount)
  
  Add(*S.IAIMPString)
  Add2(Chars.s, CharsCount)
  
  ChangeCase(Mode)
  Clone(*S.IAIMPString)
  
  Compare(*S.IAIMPString, *CompareResult, IgnoreCase)
  Compare2(Chars.s, CharsCount, *CompareResult, IgnoreCase)
  
  Delete(Index, Count)
  
  Find(*S.IAIMPString, *Index.Integer, Flags, StartFromIndex)
  Find2(Chars.s, CharsCount, *Index.Integer, Flags, StartFromIndex)
  
  Insert(Index, *S.IAIMPString)
  Insert2(Index, Chars.s, CharsCount)
  
  Replace(*OldPattern.IAIMPString, *NewPattern.IAIMPString, Flags)
  Replace2(OldPatternChars.s, OldPatternCharsCount,
           NewPatternChars.s, NewPatternCharsCount, Flags)
  
  SubString(Index, Count, *S.IAIMPString)
EndInterface

; IAIMPStream

Interface IAIMPStream Extends IUnknown
  GetSize.q()
  SetSize(Value.q)
  GetPosition.q()
  Seek(Offset.q, Mode)
  Read(*Buffer.Ascii, Count)
  Write(*Buffer.Ascii, Count, *Written.Integer)
EndInterface

; IAIMPFileStream

Interface IAIMPFileStream Extends IAIMPStream
  GetClipping(*Offset.Quad, *Size.Quad)
  GetFileName(*S.IAIMPString)
EndInterface

; IAIMPMemoryStream

Interface IAIMPMemoryStream Extends IAIMPStream
  GetData()
EndInterface

; IAIMPErrorInfo

Interface IAIMPErrorInfo Extends IUnknown
  GetInfo(*ErrorCode.Integer, *Message.IAIMPString, *Details.IAIMPString)
  GetInfoFormatted(*S.IAIMPString)
  SetInfo(ErrorCode, *Message.IAIMPString, *Details.IAIMPString)
EndInterface

; IAIMPImage

Interface IAIMPImage Extends IUnknown
  LoadFromFile(*FileName.IAIMPString)
  LoadFromStream(*Stream.IAIMPStream)
  SaveToFile(*FileName.IAIMPString, FormatID)
  SaveToStream(*Stream.IAIMPStream, FormatID)
  GetFormatID()
  GetSize(*size)
  Clone(*Image.IAIMPImage)
  Draw(DC, *R.RECT, Flags.l, *Attrs.IUnknown)
  Resize(Width, Height)
EndInterface

; IAIMPImage2

Interface IAIMPImage2 Extends IAIMPImage
  LoadFromResource(ResInstance, ResName.s, ResType.s)
  LoadFromBitmap(Bitmap)
  LoadFromBits(*Bits.RGBQUAD, Width, Height)
  CopyToClipboard()
  CanPasteFromClipboard()
  PasteFromClipboard()
EndInterface


; IAIMPImageContainer

Interface IAIMPImageContainer Extends IUnknown
  CreateImage(*Image.IAIMPImage)
  GetInfo(*Size, *FormatID.Integer)
  GetData()
  GetDataSize.l()
  SetDataSize(Value.l)
EndInterface

; IAIMPProgressCallback

Interface IAIMPProgressCallback Extends IUnknown
  Process(Progress.f, *Canceled.Byte)
EndInterface

; IAIMPPropertyList

Interface IAIMPPropertyList Extends IUnknown
  BeginUpdate()
  EndUpdate()
  Reset()
  ; Read
  GetValueAsFloat(PropertyID, *Value.Double)
  GetValueAsInt32(PropertyID, *Value.Integer)
  GetValueAsInt64(PropertyID, *Value.Quad)
  GetValueAsObject(PropertyID, *IID.REFIID, *Value)
  ; Write
  SetValueAsFloat(PropertyID, Value.d)
  SetValueAsInt32(PropertyID, Value.i)
  SetValueAsInt64(PropertyID, Value.q)
  SetValueAsObject(PropertyID, *Value.IUnknown)
EndInterface

; IAIMPPropertyList2

Interface IAIMPPropertyList2 Extends IAIMPPropertyList
  GetValueAsVariant(PropertyID, *Value.VARIANT)
  SetValueAsVariant(PropertyID, *Value.VARIANT)
EndInterface

; IAIMPConfig

Interface IAIMPConfig Extends IUnknown
  ; Delete
  Delete(*KeyPath.IAIMPString)
  ; Read
  GetValueAsFloat(*KeyPath.IAIMPString, *Value.Double)
  GetValueAsInt32(*KeyPath.IAIMPString, *Value.Integer)
  GetValueAsInt64(*KeyPath.IAIMPString, *Value.Quad)
  GetValueAsStream(*KeyPath.IAIMPString, *Value.IAIMPStream)
  GetValueAsString(*KeyPath.IAIMPString, *Value.IAIMPString)
  ; Write
  SetValueAsFloat(*KeyPath.IAIMPString, Value.d)
  SetValueAsInt32(*KeyPath.IAIMPString, Value.i)
  SetValueAsInt64(*KeyPath.IAIMPString, Value.q)
  SetValueAsStream(*KeyPath.IAIMPString, *Value.IAIMPStream)
  SetValueAsString(*KeyPath.IAIMPString, *Value.IAIMPString)
EndInterface

;}

;- apiCore
;{

DataSection
  IID_IAIMPCore:
  Data.l $41494D50
  Data.u $436F, $7265
  Data.a $00, $00, $00, $00, $00, $00, $00, $00
  
  IID_IAIMPServiceConfig:
  Data.l $41494D50
  Data.u $5372, $7643
  Data.a $66, $67, $00, $00, $00, $00, $00, $00
  
  IID_IAIMPServiceShutdown:
  Data.l $41494D50
  Data.u $5372, $7653
  Data.a $68, $75, $74, $64, $6F, $77, $6E, $00
  
  IID_IAIMPServiceVersionInfo:
  Data.l $41494D50
  Data.u $5372, $7656
  Data.a $65, $72, $49, $6E, $66, $6F, $00, $00
  
  IID_IAIMPServiceAttrExtendable:
  Data.l $41494D50
  Data.u $5372, $7641
  Data.a $74, $74, $72, $45, $78, $74, $00, $00
  
  IID_IAIMPServiceAttrObjects:
  Data.l $41494D50
  Data.u $5372, $7641
  Data.a $74, $74, $72, $4F, $62, $6A, $73, $00
EndDataSection


; IAIMPServiceVersionInfo.GetBuildState
#AIMP_SERVICE_VERSION_STATE_RELEASE           = 0;
#AIMP_SERVICE_VERSION_STATE_RELEASE_CANDIDATE = 1;
#AIMP_SERVICE_VERSION_STATE_BETA              = 2;
#AIMP_SERVICE_VERSION_STATE_ALPHA             = 3;

; IAIMPServiceShutdown.Shutdown
#AIMP_SERVICE_SHUTDOWN_FLAGS_HIBERNATE  = $1;
#AIMP_SERVICE_SHUTDOWN_FLAGS_POWEROFF   = $2;
#AIMP_SERVICE_SHUTDOWN_FLAGS_SLEEP      = $3;
#AIMP_SERVICE_SHUTDOWN_FLAGS_REBOOT     = $4;
#AIMP_SERVICE_SHUTDOWN_FLAGS_LOGOFF     = $5;
#AIMP_SERVICE_SHUTDOWN_FLAGS_CLOSE_APP  = $10;
#AIMP_SERVICE_SHUTDOWN_FLAGS_NO_CONFIRM = $20;

; IAIMPCore.GetPath
#AIMP_CORE_PATH_AUDIOLIBRARY = 6;
#AIMP_CORE_PATH_ENCODERS     = 8;
#AIMP_CORE_PATH_HELP         = 9;
#AIMP_CORE_PATH_ICONS        = 5;
#AIMP_CORE_PATH_LANGS        = 2;
#AIMP_CORE_PATH_PLAYLISTS    = 1;
#AIMP_CORE_PATH_PLUGINS      = 4;
#AIMP_CORE_PATH_PROFILE      = 0;
#AIMP_CORE_PATH_SKINS        = 3;
#AIMP_CORE_PATH_SKINS_COMMON = 11;

; IAIMPCore

Interface IAIMPCore Extends IUnknown
  ; Creating Simple Objects
  CreateObject(*IID.REFIID, *Obj)
  ; System Paths
  GetPath(PathID.i,  *Value.IAIMPString)
  ; Registration
  RegisterExtension(*ServiceIID.REFIID, *Extension.IUnknown)
  RegisterService(*Service.IUnknown)
  UnregisterExtension(*Extension.IUnknown)
EndInterface

; IAIMPServiceAttrObjects

Interface IAIMPServiceAttrObjects Extends IUnknown
  CreateObject(*IID.REFIID, *Obj)
EndInterface


; IAIMPServiceAttrExtendable

Interface IAIMPServiceAttrExtendable Extends IUnknown
  RegisterExtension(*Extension.IUnknown)
  UnregisterExtension(*Extension.IUnknown)
EndInterface


; IAIMPServiceConfig

Interface IAIMPServiceConfig Extends IAIMPConfig
  FlushCache()
EndInterface


; IAIMPServiceShutdown

Interface IAIMPServiceShutdown Extends IUnknown
  Restart(*Params.IAIMPString)
  Shutdown(Flags.l)
EndInterface


; IAIMPServiceVersionInfo

Interface IAIMPServiceVersionInfo Extends IUnknown
  FormatInfo( *S.IAIMPString)
  GetBuildDate()
  GetBuildState()
  GetBuildNumber()
  GetVersionID()
EndInterface

;}



;- apiPlugin
;{
; IAIMPPlugin.InfoGetCategories
#AIMP_PLUGIN_CATEGORY_ADDONS   = $1;
#AIMP_PLUGIN_CATEGORY_DECODERS = $2;
#AIMP_PLUGIN_CATEGORY_VISUALS  = $4;
#AIMP_PLUGIN_CATEGORY_DSP	     = $8;

; IAIMPPlugin.InfoGet
#AIMP_PLUGIN_INFO_NAME              = $0;
#AIMP_PLUGIN_INFO_AUTHOR            = $1;
#AIMP_PLUGIN_INFO_SHORT_DESCRIPTION = $2;
#AIMP_PLUGIN_INFO_FULL_DESCRIPTION  = $3;

; IAIMPPlugin.SystemNotification
#AIMP_SYSTEM_NOTIFICATION_SERVICE_ADDED   = $1;
#AIMP_SYSTEM_NOTIFICATION_SERVICE_REMOVED = $2;
#AIMP_SYSTEM_NOTIFICATION_EXTENSION_REMOVED = $3;

DataSection
  IID_IAIMPExternalSettingsDialog:
  Data.l $41494D50
  Data.u $4578, $7472
  Data.a $6E, $4F, $70, $74, $44, $6C, $67, $00
EndDataSection

Interface IAIMPExternalSettingsDialog Extends IUnknown
  Show(ParentWindow)
EndInterface

Interface IAIMPPlugin Extends IUnknown
  InfoGet.s(Index.i)
  InfoGetCategories.l()
  Initialize(*Core.IAIMPCore)
  Finalize()
  SystemNotification(NotifyID.i, *Data.IUnknown)
EndInterface

;}


;- apiVisuals
;{


DataSection
  IID_IAIMPExtensionCustomVisualization:
  Data.l $41494D50
  Data.u $4578, $7443
  Data.a $73, $74, $6D, $56, $69, $73, $00, $00
  
  IID_IAIMPExtensionEmbeddedVisualization:
  Data.l $41494D50
  Data.u $4578, $7445
  Data.a $6D, $62, $64, $56, $69, $73, $00, $00
  
  IID_IAIMPServiceVisualizations:
  Data.l $41494D50
  Data.u $5372, $7656
  Data.a $69, $73, $75, $61, $6C, $00, $00, $00
EndDataSection


; Button ID For IAIMPExtensionEmbeddedVisualization.Click
#AIMP_VISUAL_CLICK_BUTTON_LEFT   = 0;
#AIMP_VISUAL_CLICK_BUTTON_MIDDLE = 1;

; flags For IAIMPExtensionEmbeddedVisualization.GetFlags And IAIMPExtensionCustomVisualization.GetFlags
#AIMP_VISUAL_FLAGS_RQD_DATA_WAVE       = 1;
#AIMP_VISUAL_FLAGS_RQD_DATA_SPECTRUM   = 2;
#AIMP_VISUAL_FLAGS_NOT_SUSPEND     = 4    ;

#AIMP_VISUAL_SPECTRUM_MAX = 256;
#AIMP_VISUAL_WAVEFORM_MAX = 512;

Structure TAIMPVisualDataSpectrum
  Arr.f[#AIMP_VISUAL_SPECTRUM_MAX]
EndStructure

Structure TAIMPVisualDataWaveform
  Arr.f[#AIMP_VISUAL_WAVEFORM_MAX];
EndStructure


Structure TAIMPVisualData
  Peaks.f[2]
  Spectrum.TAIMPVisualDataSpectrum[3]
  WaveForm.TAIMPVisualDataWaveform[2]
  Reserved.i
EndStructure


; IAIMPVisualExtension

Interface IAIMPExtensionCustomVisualization Extends IUnknown
  ; Common Information
  GetFlags()
  ; Basic functionality
  Draw(*Data.TAIMPVisualData)
EndInterface

; IAIMPExtensionEmbeddedVisualization

Interface IAIMPExtensionEmbeddedVisualization Extends IUnknown
  ; Common Information
  GetFlags()
  GetMaxDisplaySize(*Width.Integer, *Height.Integer)
  GetName(*S.IAIMPString)
  ; Initialization / Finalization
  Initialize(Width, Height)
  Finalize()
  ; Basic functionality
  Click(X, Y, Button)
  Draw(DC, *Data.TAIMPVisualData)
  Resize(NewWidth, NewHeight)
EndInterface

; IAIMPServiceVisual

Interface IAIMPServiceVisualizations Extends IUnknown
EndInterface

;}


DataSection
  IID_IUnknown:
  Data.l $00000000
  Data.u $0000, $0000
  Data.a $C0, $00, $00, $00, $00, $00, $00, $46
EndDataSection

EndDeclareModule

Module AIMP
EndModule

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; Folding = --
; EnableUnicode
; EnableXP