﻿DeclareModule Visual
Declare Create(*CB)
Declare Free(*This)
EndDeclareModule

Module Visual

UseModule AIMP
UseModule Unknown

Prototype pCB(*Data.TAIMPVisualData)

Structure Visual Extends UnkSctuct
  *CB.pCB
EndStructure

EnableExplicit


Procedure GetFlags(*This.Visual)
  ProcedureReturn #AIMP_VISUAL_FLAGS_RQD_DATA_SPECTRUM ;| #AIMP_VISUAL_FLAGS_RQD_DATA_WAVE
EndProcedure

Procedure Draw(*This.Visual, *Data.TAIMPVisualData)
  If *This\CB
    *This\CB(*Data)
  EndIf
EndProcedure

Procedure Create(*CB)
  Protected *Struct.Visual
  
  *Struct = AllocateMemory(SizeOf(Visual))
  If *Struct
    InitializeStructure(*Struct, Visual)
    ;CopyMemory(AIMP::?IID_IAIMPExtensionCustomVisualization, @*Struct\IID, SizeOf(GUID))
    CopyMemory(?__IID_IAIMPExtensionCustomVisualization, @*Struct\IID, SizeOf(GUID))
    *Struct\VT = ?Proc
    *Struct\CB = *CB
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Proc:
    Unknown::UnkProc
    Data.i @GetFlags()
    Data.i @Draw()
    
     __IID_IAIMPExtensionCustomVisualization:
    Data.l $41494D50
    Data.u $4578, $7443
    Data.a $73, $74, $6D, $56, $69, $73, $00, $00
  EndDataSection
EndProcedure

Procedure Free(*This.Visual)
  Protected Res = #False
  
  If *This
    ClearStructure(*This, Visual)
    FreeMemory(*This)
    Res = #True
  EndIf
  
  ProcedureReturn Res
EndProcedure

EndModule
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 36
; FirstLine = 29
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory