﻿#AIMP_VISUAL_SPECTRUM_MAX = 256;
#AIMP_VISUAL_WAVEFORM_MAX = 512;

Structure TAIMPVisualDataSpectrum
  Arr.f[#AIMP_VISUAL_SPECTRUM_MAX]
EndStructure

Structure TAIMPVisualDataWaveform
  Arr.f[#AIMP_VISUAL_WAVEFORM_MAX];
EndStructure


Structure TAIMPVisualData
  Peaks.f[2]
  Spectrum.TAIMPVisualDataSpectrum[3]
  WaveForm.TAIMPVisualDataWaveform[2]
  Reserved.i
EndStructure

Procedure CB(*Data.TAIMPVisualData)
  PrintN(StrF(*Data\Spectrum[2]\Arr[120]))
EndProcedure

OpenConsole()

If OpenLibrary(0, "VisualShare.dll")
  CallFunction(0, "LibInit")
  CallFunction(0, "SetCallBack", @CB(), #True)
  MessageRequester("","Нажмите на 'OK' для завершения работы программы")
  CallFunction(0, "LibFree")
  CloseLibrary(0)
Else
  PrintN("Не удалось загрузить библиотеку")
  Input()
EndIf
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 29
; Folding = -
; EnableUnicode
; EnableThread
; Executable = Консоль.exe