﻿#AIMP_VISUAL_SPECTRUM_MAX = 256;
#AIMP_VISUAL_WAVEFORM_MAX = 512;

Structure TAIMPVisualDataSpectrum
  Arr.f[#AIMP_VISUAL_SPECTRUM_MAX]
EndStructure

Structure TAIMPVisualDataWaveform
  Arr.f[#AIMP_VISUAL_WAVEFORM_MAX];
EndStructure


Structure TAIMPVisualData
  Peaks.f[2]
  Spectrum.TAIMPVisualDataSpectrum[3]
  WaveForm.TAIMPVisualDataWaveform[2]
  Reserved.i
EndStructure

Sp.TAIMPVisualData

OpenConsole("Для закрытия окна нажмите на 'Enter'")

If OpenLibrary(0, "VisualShare.dll")
  CallFunction(0, "LibInit")
  Repeat
    If CallFunction(0, "IsData")
      If CallFunction(0, "GetData", @Sp)
        PrintN(StrF(Sp\Spectrum[2]\Arr[120]))
      Else
        PrintN("Error")
      EndIf
    Else
      PrintN("Wait")
    EndIf
    Delay(10)
  Until Inkey()=#CR$
  CallFunction(0, "LibFree")
  CloseLibrary(0)
Else
  PrintN("Не удалось загрузить библиотеку")
  Input()
EndIf
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 37
; FirstLine = 2
; EnableUnicode
; Executable = Консоль_IsData.exe